package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
import Domain_Repository.*;
import org.omg.CORBA.*;

/////////////////////////////////////
/* This class support Property objects */
////////////////////////////////////////

class PWindow extends JDialog{

   JTextField name;
   JButton anybutton;
   JButton cancel;
   JButton accept;
   boolean answer;
   JDialog wnd;
   org.omg.CORBA.Any any;

   public PWindow(Window parent){
      super((JFrame)parent, "Property description", true);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(230,180);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      wnd = this;
      answer = false;
      any = org.omg.CORBA.ORB.init().create_any();

      JLabel label = new JLabel("Name:");
      label.setSize(200,15);
      label.setLocation(10,10);
      pane.add(label);
      name = new JTextField();
      name.setSize(200,20);
      name.setLocation(10,30);
      pane.add(name);
 
      ButtonClicked bc = new ButtonClicked();

      label = new JLabel("Value:");
      label.setSize(200,15);
      label.setLocation(10,60);
      pane.add(label);
      anybutton = new JButton("Any Type");
      anybutton.setSize(200,20);
      anybutton.setLocation(10,80);
      anybutton.addActionListener(bc);
      pane.add(anybutton);

      cancel = new JButton("Cancel");
      cancel.setSize(80,30);
      cancel.setLocation(110, 110);
      cancel.addActionListener(bc);
      pane.add(cancel);
 
      accept = new JButton("Accept");
      accept.setSize(80,30);
      accept.setLocation(20,110);
      accept.addActionListener(bc);
      pane.add(accept);
      setContentPane(pane);
   }
 
   public boolean getAnswer() { return answer; }
 
   public void setData(Property pr){
      name.setText(pr.name);
      any = pr.value;
   }

   public Property getProperty(){
      return new Property(name.getText(), any);
   }

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            answer = true;
            setVisible(false);
         }
         else if (((JButton) e.getSource()) == cancel){
            setVisible(false);
         }
         else if (((JButton) e.getSource()) == anybutton){
///////////////////////////////////////////////////////////////////
/* Here you can show AnyEditor to user. If you need some data to do this you can
   get it from "any" varible. if you want to get some data from the dialog you shoud 
   put it into "any" varible. It could be done like this for example.
  
   AnyEditor editor = new AnyEditor(any.type());
   MyListener listener = new MyListener();
   editor.addListener(listener);
// and some Any objects you could read as parameter of event, witch
   you support in your listener (i suppose so). You should store it 
   in "any" varible, because it's used for bilding new Propery object*/
//////////////////////////////////////////////////////////////////////////
         }
      }
   }
}
