/*
 * X_gui.hh
 * (c) 1998 Dariusz bik <zbik@dwd.interkom.pl>
 */

#ifndef _ABNG_X_GUI_HH
#define _ABNG_X_GUI_HH

#include <Xm/PushB.h>

#include "abng_lock_setup.hh"

struct x_gui_resrcs{
  Boolean quiet;
  char * command;
  char * username;
  char * viewname;
};

class X_abng : public abng_lock_setup {
public:
  /* local */
  X_abng(int argc, char *argv[]);
  virtual ~X_abng();

  /* from abng_lock_setup */
  virtual const char *lock_args(void) const;
  virtual const char *viewname(void) const;
  virtual const char *username(void) const;
  virtual int quiet_mode(void) const;
protected:
  static XtResource resources[];
  static XrmOptionDescRec options[];
  struct x_gui_resrcs Resrcs;

  Display *dpy;
  XtAppContext app;
  Widget toplevel;
};

#endif /* _ABNG_X_GUI_HH */

/*END*/
