/*
 * X_screen_lock.hh
 * (c) 1998 Dariusz bik <zbik@dwd.interkom.pl>
 */

#ifndef _X_SCREEN_LOCK_HH
#define _X_SCREEN_LOCK_HH

#define DEFAULT_LOCK_COMMEND "xlock -r -mode blank" 

#include <sys/types.h>
#include "screen_lock.hh"

class X_screen_lock : public screen_lock {
public:
  X_screen_lock(const char *lock_commend=DEFAULT_LOCK_COMMEND);
  virtual ~X_screen_lock();
  virtual void lock(void);
  virtual void unlock(void);
protected:
  pid_t child;
  char *argbuff;
  char **args;
};

#endif /* _X_SCREEN_LOCK_HH */

/*END*/
