package szTools.console;

/**
 * Null implementation of the Console interface.
 */
public class NullConsole implements Console {
  static NullConsole instance = null;

  public Console getInstance() {
    return instance;
  }

  public NullConsole() {
    instance = this;
  }

  public void trace( String txt ) {}
  public void addWriter( Object writer, String name ) {}
  public void messageFrom( Object writer, String txt ) {}
  public void exception( Object writer, Exception exception ) {}
  public void display() {
    System.err.println( "Null console attached." );
  }
};
