CXX = CC
RM  = rm -f
AR  = ar cq
RANLIB = ranlib 

# To use Solaris threads, uncomment the following 2 lines:
#OMNITHREAD_LIB = -L$(TOP)/lib -lomnithread -lthread
#OMNITHREAD_CPPFLAGS = -I$(TOP)/include -D__sunos__ -D__sparc__ -D__OSVERSION__=5 -DSVR4 -D_REENTRANT 

# To use Posix threads, uncomment the following lines:
OMNITHREAD_POSIX_CPPFLAGS = -DPthreadDraftVersion=10 -DPthreadSupportThreadPriority 

OMNITHREAD_LIB = -L$(TOP)/lib -lomnithread -lpthread -lposix4
OMNITHREAD_CPPFLAGS = -I$(TOP)/include \
                       -D__sunos__ -D__sparc__ -D__OSVERSION__=5 -DSVR4 \
                      -DUsePthread -D_REENTRANT

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<
