// -*- Mode: C++; -*-
//
// $Id: LDescr_Main.java,v 1.3 1998/07/03 12:50:10 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/location_description_rep/LDescr/LDescr_Main.java,v $
//
// $Log: LDescr_Main.java,v $
// Revision 1.3  1998/07/03 12:50:10  mencnar
// moved common files to "common_java" directory
//
// Revision 1.2  1998/06/18 09:19:22  mencnar
// *** empty log message ***
//
// Revision 1.1  1998/01/28 08:23:51  mencnar
// Initial revision
//
//

package pl.edu.agh.ics.abngcore;

class LDescr_Run extends Thread {
public void run() {
  System.err.println("impl_is_ready");
  LDescr_Main.my_orb_wrapper.impl_is_ready();
}
};

public class LDescr_Main {
  public static String Repository_DB = "Location_Description.db";

  public static ORB_wrapper my_orb_wrapper;

  private static void usage() {
    System.out.println("Usage: ldescr [options]\nThe following options can be used:\n-s \t\t Used when server is launched for the the first time (cold start)\n-d directory \t Specify the database directory");
    System.exit( 1);
  }

  public static void main( String argv[]) {
    System.err.println("main");
    my_orb_wrapper= new ORB_wrapper();

    my_orb_wrapper.init_application( argv);

    LDescr_Rep ldescr_rep= null;
    System.err.println("<<Bootstrap_init");
    Bootstrap_n.init();
    System.err.println(">>Bootstrap_init");
    boolean coldstart= false;
    String db_directory= null;

    for (int i=0; i<argv.length; i++) {
      if ( argv[ i].equals("-s")) coldstart= true;
      else if ( argv[ i].equals("-d")) {
	if ( i+1 == argv.length) usage();
	if ( db_directory == null) db_directory= argv[ i+1];
	else db_directory= argv[ i+1]+"/"+db_directory;
      }
      else usage();		    
    }
    if ( db_directory != null) Repository_DB= db_directory+"/"+Repository_DB;

    try {
      ldescr_rep= new LDescr_Rep( Repository_DB, 
				  coldstart);
      ldescr_rep.start();
      my_orb_wrapper.connect_object( ldescr_rep.get_repository_object());
      my_orb_wrapper.connect_object( ldescr_rep.get_manager_object());
      new Process_Status( "location_description_repository", null);
    }
    catch ( Exception ex) {
	System.err.println( "Caught exception while instantiating server object " +ex);
	ex.printStackTrace();
	System.exit( 1);
    }    
    System.err.println("Calling impl_is_ready");
    for (int xi=0; xi<10; xi++)
      (new LDescr_Run()).start();
  }
}
