// $Id: sched_barrier_id.cc,v 1.2 1998/06/18 10:21:56 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/scheduler/sched_barrier_id.cc,v $
//
// $Log: sched_barrier_id.cc,v $
// Revision 1.2  1998/06/18 10:21:56  mencnar
// moved to CVS
//
// Revision 1.1  1997/10/23 09:19:13  mencnar
// Initial revision
//
//

#include "sched_main.hh"

//-----------------------------------------------------------Sched_Barrier_Id
//
int Sched_Barrier_Id::operator == ( const Sched_Barrier_Id &bar) const {

  if (is_badge_id + bar.is_badge_id == 1) return 0;

  if (is_badge_id == 1 || bar.is_badge_id == 1) 
	return (badge_id == bar.badge_id);
  else 
    	return (network_id == bar.network_id && 
		station_id == bar.station_id &&
		group_name == bar.group_name);
}

Sched_Barrier_Id::operator ABng_Core_System::Sensor_Id() const {
  ABng_Core_System::Sensor_Id sensor_id;

  sensor_id.sensor_num= (ABng_Core_System::Sensor_Number) station_id;
  sensor_id.network_num= (ABng_Core_System::Network_Number) network_id;
  sensor_id.group_name= group_name;

  return sensor_id;
}

unsigned Sched_Barrier_Id::hash( const Sched_Barrier_Id &bar) {
  unsigned ret= 0;

  switch (bar.is_badge_id) {
  case 0:
    {
      ret+= (unsigned) bar.station_id;
      ret+= (unsigned) bar.network_id;
    }
    break;
  case 1:
    {
      int len= bar.badge_id.length();
      for (int i=0; i<len; i++)
	ret+= (unsigned) bar.badge_id[i];
    }
    break;
  }
  return ret;
}


