// $Id: comparable_sensor_descr.cc,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/comparable_sensor_descr.cc,v $
//
// $Log: comparable_sensor_descr.cc,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:24:01  jasz
// Initial revision
//
//
// File:          comparable_sensor_descr.cc
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Definition of the Comparable_Sensor_Descr class. It encapsulates sensor 
//  data and provides an equality testing operator.

#include <string.h>
#include "comparable_sensor_descr.h"

Comparable_Sensor_Descr::Comparable_Sensor_Descr() : 
  ABng_Core_System::Sensor::Description() {

  id.group_name= CORBA::string_dup("");
}

unsigned Comparable_Sensor_Descr::hash(
  const Comparable_Sensor_Descr& sd_p) {

  return sd_p.item_id;
}
