#ifndef __ALD_CLIENT_H__
#define __ALD_CLIENT_H__ 1

#include <stream.h>

#include "abng_core_types.h"
#include "bootstrap_n.hh"
#include "rep_client.h"



class ABng_Loc_Descr_Rep_Client : 
   public Rep_Client<ABng_Location_Description_Types> {

public:

  ABng_Loc_Descr_Rep_Client() : 
     Rep_Client<ABng_Location_Description_Types>(
        Bootstrap::SRV_ABng_Location_Description_Repository,
        Bootstrap::SRV_ABng_Location_Description_Repository
     ) {
     sensor_rep = new Basic_Client<Sensor_Types>(
			 Bootstrap::SRV_Sensor_Repository
                  );
     ld_rep = new Basic_Client<Location_Description_Types>(
                         Bootstrap::SRV_Location_Description_Repository
                  );
  }

  virtual ~ABng_Loc_Descr_Rep_Client() {}

  virtual ABng_Core_System::ABng_Location_Description::Description
     init_data(char* data);

  virtual void other_operations();

  protected:
   Basic_Client<Sensor_Types>* sensor_rep;
   Basic_Client<Location_Description_Types>* ld_rep;

};

#endif __ALD_CLIENT_H__





