#ifndef __LDR_CLIENT_H__
#define __LDR_CLIENT_H__ 1

#include <stream.h>

#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"

#include "rep_client.h"

ostream& 
 operator << (ostream&, Domain_Repository::Location_Description::Value_Description&);



class LDescr_Client : public Rep_Client<Location_Description_Types_Mgr> {

public:

  LDescr_Client(resolve_fun _srv_rep, resolve_fun _srv_rep_mgr)
    : Rep_Client<Location_Description_Types_Mgr>(_srv_rep, _srv_rep_mgr) {
    location_type_rep = new Basic_Client<Location_Type_Types>(
      Bootstrap::SRV_Location_Type_Repository);
  }

  virtual ~LDescr_Client() {}

  virtual Domain_Repository::Location_Description::Description init_data(char* data);

  protected:
    Basic_Client<Location_Type_Types>* location_type_rep;

};

#endif __LDR_CLIENT_H__





