
#include "tevent_data_observed_r.hh"

TEvent_Data_Observed_R_mgr::TEvent_Data_Observed_R_mgr () 
{
    _ptr = TEvent_Data_Observed_R:: _nil ();
}

TEvent_Data_Observed_R_mgr::TEvent_Data_Observed_R_mgr (const TEvent_Data_Observed_R_mgr &IT_s) 
{
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s._ptr);
}

TEvent_Data_Observed_R_mgr::TEvent_Data_Observed_R_mgr (TEvent_Data_Observed_R_var IT_s) 
{
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s);
}

TEvent_Data_Observed_R_mgr::TEvent_Data_Observed_R_mgr (const TEvent_Data_Observed_R_SeqElem &IT_s) 
{
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s);
}

TEvent_Data_Observed_R_mgr &TEvent_Data_Observed_R_mgr::operator= (TEvent_Data_Observed_R_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_R_mgr &TEvent_Data_Observed_R_mgr::operator= (const TEvent_Data_Observed_R_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate(IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_R_mgr &TEvent_Data_Observed_R_mgr::operator= (TEvent_Data_Observed_R_var IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate(IT_s);
    return (*this);
}

TEvent_Data_Observed_R_mgr &TEvent_Data_Observed_R_mgr::operator= (const TEvent_Data_Observed_R_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate(IT_s);
    return (*this);
}

TEvent_Data_Observed_R_mgr::~TEvent_Data_Observed_R_mgr () {
    CORBA::release (_ptr);
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_mgr:: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_R_mgr::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Data_Observed_R_mgr::operator TEvent_Data_Observed_R_ptr& () { return (TEvent_Data_Observed_R_ptr &) (_ptr);}
TEvent_Data_Observed_R_mgr::operator const TEvent_Data_Observed_R_ptr& () const { return (TEvent_Data_Observed_R_ptr &) (_ptr);}

TEvent_Data_Observed_R_mgr::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_mgr:: in () const {
    return _ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_mgr:: inOut () {
    return _ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_mgr:: out () {
    return _ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_mgr:: ret () const {
    return _ptr;
}

TEvent_Data_Observed_R_SeqElem::TEvent_Data_Observed_R_SeqElem (TEvent_Data_Observed_R_ptr* IT_p, unsigned char rel) {
    _ptr = IT_p;
    _release = rel;
}

TEvent_Data_Observed_R_SeqElem &TEvent_Data_Observed_R_SeqElem::operator= (TEvent_Data_Observed_R_ptr IT_p) {
    if (_ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = IT_p;
    }
    return (*this);
}

TEvent_Data_Observed_R_SeqElem &TEvent_Data_Observed_R_SeqElem::operator= (const TEvent_Data_Observed_R_SeqElem &IT_s) {
    if (_ptr && IT_s._ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_R:: _duplicate(*(IT_s._ptr));
    }
    return (*this);
}

TEvent_Data_Observed_R_SeqElem &TEvent_Data_Observed_R_SeqElem::operator= (const TEvent_Data_Observed_R_mgr &IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_R:: _duplicate(IT_s._ptr);
    }
    return (*this);
}

TEvent_Data_Observed_R_SeqElem &TEvent_Data_Observed_R_SeqElem::operator= (TEvent_Data_Observed_R_var IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_R:: _duplicate (IT_s);
    }
    return (*this);
}

TEvent_Data_Observed_R_SeqElem::operator ! () const {
    return ((CORBA::is_nil (*_ptr)));
}

TEvent_Data_Observed_R_SeqElem::operator const TEvent_Data_Observed_R_ptr& () const { return (TEvent_Data_Observed_R_ptr &) (*_ptr);}

TEvent_Data_Observed_R_SeqElem::operator CORBA::Object_ptr () const {
    return *_ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_SeqElem:: in () const {
    return *_ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_SeqElem:: inOut () {
    return *_ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_SeqElem:: out () {
    return *_ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_SeqElem:: ret () const {
    return *_ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_SeqElem::operator->() const { return *_ptr;}

TEvent_Data_Observed_R::TEvent_Data_Observed_R (char *IT_OR) {
      m_pptr = new TEvent_Data_Observed_R_dispatch (IT_OR, this,(CORBA::Object*)this);
} 
TEvent_Data_Observed_R::TEvent_Data_Observed_R (ObjectReferenceImpl *IT_OR) {
      m_pptr = new TEvent_Data_Observed_R_dispatch (IT_OR, this,(CORBA::Object*)this);
} 

#ifndef TEvent_Data_Observed_RForwC
#define TEvent_Data_Observed_RForwC
CORBA::ObjectRef CALL_SPEC TEvent_Data_Observed_R_getBase(void *IT_p){
    return (TEvent_Data_Observed_R*) IT_p;}

void CALL_SPEC TEvent_Data_Observed_R_release (TEvent_Data_Observed_R_ptr IT_p, CORBA::Environment &IT_env) {
    CORBA::release(IT_p, IT_env);}

void CALL_SPEC TEvent_Data_Observed_R_release (TEvent_Data_Observed_R_ptr IT_p) {
    TEvent_Data_Observed_R_release (IT_p, CORBA::IT_chooseDefaultEnv ()); }

TEvent_Data_Observed_R_ptr CALL_SPEC TEvent_Data_Observed_R_nil (CORBA::Environment &) {
    return TEvent_Data_Observed_R:: _nil ();}

TEvent_Data_Observed_R_ptr CALL_SPEC TEvent_Data_Observed_R_nil () {
    return TEvent_Data_Observed_R_nil (CORBA::IT_chooseDefaultEnv ());}

TEvent_Data_Observed_R_ptr CALL_SPEC TEvent_Data_Observed_R_duplicate (TEvent_Data_Observed_R_ptr IT_p, CORBA::Environment &IT_env) {
    return (TEvent_Data_Observed_R::_duplicate(IT_p, IT_env)); }
TEvent_Data_Observed_R_ptr CALL_SPEC TEvent_Data_Observed_R_duplicate (TEvent_Data_Observed_R_ptr IT_p) {
    return TEvent_Data_Observed_R_duplicate (IT_p, CORBA::IT_chooseDefaultEnv ()); }
#endif

TEvent_Data_Observed_R_ptr CALL_SPEC TEvent_Data_Observed_R::_duplicate(TEvent_Data_Observed_R_ptr obj, CORBA::Environment& IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
       if (!obj) {
          return (obj);
       }
       TEvent_Data_Observed_R_ptr IT_obj = obj->__duplicate (IT_env);
       return IT_obj;
}



TEvent_Data_Observed_R* CALL_SPEC TEvent_Data_Observed_R:: _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env) {
       return (TEvent_Data_Observed_R*)CORBA::Factory.New (IT_markerServer, IT_env, IT_c, host, 
		TEvent_Data_Observed_R_IMPL, TEvent_Data_Observed_R_IR);
}



TEvent_Data_Observed_R* CALL_SPEC TEvent_Data_Observed_R:: _bind (CORBA::Environment &IT_env) {
       return _bind (NULL,NULL,CORBA::Context(), IT_env); }


TEvent_Data_Observed_R* CALL_SPEC TEvent_Data_Observed_R:: _bind (const char* IT_markerServer, const char* host,
                CORBA::Environment &IT_env) {
       return _bind (IT_markerServer, host, CORBA::Context (), IT_env); }
TEvent_Data_Observed_R* CALL_SPEC TEvent_Data_Observed_R::_narrow (CORBA::Object* IT_obj, CORBA::Environment &IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        if (CORBA::is_nil (IT_obj)) {
                return TEvent_Data_Observed_R:: _nil();
        }

       TEvent_Data_Observed_R* IT_p = (TEvent_Data_Observed_R*)CORBA::Object::_castDown (IT_obj, TEvent_Data_Observed_R_IR, IT_env);
        IT_p = IT_p ? IT_p->__duplicate(IT_env) : NULL;
        if ((IT_env) &&(!strcmp(IT_env.exception()->id(), "CORBA::StExcep::BAD_PARAM")) && (((CORBA::BAD_PARAM*)IT_env.exception())-> minor() == NARROW_FAILED)) {
                IT_env.exception_free();
        }
        return IT_p;
   }

const void* TEvent_Data_Observed_R:: IT_impl = CORBA::IT_implTable.record (TEvent_Data_Observed_R_IMPL, "IDL:TEvent_Data_Observed_R:1.0");


#ifndef TEvent_Data_Observed_R_Observer_Entry_Ops
#define TEvent_Data_Observed_R_Observer_Entry_Ops

void TEvent_Data_Observed_R::Observer_Entry:: encodeOp (CORBA::Request &IT_r) const {

    IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);

    interest.encodeOp (IT_r);
}

void TEvent_Data_Observed_R::Observer_Entry:: decodeOp (CORBA::Request &IT_r) {

    obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

    interest.decodeOp (IT_r);
}

void TEvent_Data_Observed_R::Observer_Entry:: decodeInOutOp (CORBA::Request &IT_r) {

    obs = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);

    interest.decodeInOutOp (IT_r);
}

TEvent_Data_Observed_R::Observer_Entry ::~Observer_Entry () {
}

TEvent_Data_Observed_R::Observer_Entry:: Observer_Entry (const TEvent_Data_Observed_R::Observer_Entry &IT_s) 
	 : interest(IT_s.interest) {
    obs = IT_s.obs;
}

TEvent_Data_Observed_R::Observer_Entry:: Observer_Entry () {
}

TEvent_Data_Observed_R::Observer_Entry &TEvent_Data_Observed_R::Observer_Entry:: operator= (const TEvent_Data_Observed_R::Observer_Entry& IT_s) {
    if (this == &IT_s) return *this;
    obs = IT_s.obs;
    interest = IT_s.interest;
    return *this;
}

unsigned char TEvent_Data_Observed_R::Observer_Entry_var ::copyHelper (const Observer_Entry_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new Observer_Entry;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent_Data_Observed_R::Observer_Entry_ptr* TEvent_Data_Observed_R::Observer_Entry_var ::_newPtr () {
    return new TEvent_Data_Observed_R::Observer_Entry_ptr;
}

TEvent_Data_Observed_R::Observer_Entry_var ::Observer_Entry_var (const Observer_Entry_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_R::Observer_Entry_var ::Observer_Entry_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent_Data_Observed_R::Observer_Entry_var ::Observer_Entry_var (Observer_Entry_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Data_Observed_R::Observer_Entry_var &TEvent_Data_Observed_R::Observer_Entry_var :: operator= (Observer_Entry_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_R::Observer_Entry_var &TEvent_Data_Observed_R::Observer_Entry_var :: operator= (const Observer_Entry_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new Observer_Entry;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_R::Observer_Entry_var ::~Observer_Entry_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Data_Observed_R::Observer_Entry_ptr TEvent_Data_Observed_R::Observer_Entry_var :: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_R::Observer_Entry_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent_Data_Observed_R::Observer_Entry_var::operator TEvent_Data_Observed_R::Observer_Entry_ptr& () { return (TEvent_Data_Observed_R::Observer_Entry_ptr &) (_ptr);}
TEvent_Data_Observed_R::Observer_Entry_var::operator const TEvent_Data_Observed_R::Observer_Entry_cptr& () const { return (TEvent_Data_Observed_R::Observer_Entry_cptr &) (_ptr);}
TEvent_Data_Observed_R::Observer_Entry_var:: operator TEvent_Data_Observed_R::Observer_Entry& () const { return (TEvent_Data_Observed_R::Observer_Entry&) (* _ptr);}

const TEvent_Data_Observed_R::Observer_Entry TEvent_Data_Observed_R::Observer_Entry_var :: in () const {
    return *_ptr;
}

TEvent_Data_Observed_R::Observer_Entry& TEvent_Data_Observed_R::Observer_Entry_var :: inOut () {
    return *_ptr;
}

TEvent_Data_Observed_R::Observer_Entry*& TEvent_Data_Observed_R::Observer_Entry_var :: out () {
    return _ptr;
}

TEvent_Data_Observed_R::Observer_Entry* TEvent_Data_Observed_R::Observer_Entry_var :: ret () const {
    return _ptr;
}


#endif


#ifndef TEvent_Data_Observed_R__IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_Ops
#define TEvent_Data_Observed_R__IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_Ops

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: ~_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry() {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry () {
    _release = 1;
    _length = 0;
    _maximum = 0;
    _buffer = NULL;
}


TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observed_R::Observer_Entry* data, CORBA::Boolean release) {
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry (const TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry &IT_s) {
    _length = IT_s._length;
    _release = 1;
    CORBA::ULong IT_maximum = _maximum = IT_s._maximum;
    if (IT_maximum) {
        _buffer = allocbuf (IT_maximum);
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            _buffer[IT_i] = IT_s._buffer[IT_i];
        }
    } else
        _buffer = NULL;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry (CORBA::ULong IT_size) {
    if (IT_size) {
        _buffer = allocbuf (IT_size);
    } else
        _buffer = NULL;
    _length = 0;
    _release = 1;
    _maximum = IT_size;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: operator= (const TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry &IT_s){
    if (this == &IT_s) return *this;
    if (_buffer && _release) {
    }
    if (!_release || (IT_s._maximum > _maximum)) {
        if (_buffer && _release) {
            freebuf (_buffer);
        }
        _buffer = allocbuf (IT_s._maximum);
        _maximum = IT_s._maximum;
        _release = 1;
    }
    _length = IT_s._length;
    for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
        _buffer[IT_j] = IT_s._buffer[IT_j];
    }
    return *this;
}

CORBA::ULong TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: maximum () const
{
    return _maximum;
}

CORBA::ULong TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: length () const
{
    return _length;
}

void TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: length (CORBA::ULong len) {
    if (len > _maximum) {
        TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry tempSeq (*this);
        if (_buffer && _release) {
            {
            }
            freebuf (_buffer);
        }
        _release = 1;
        _length = len;
        _maximum = len;
        _buffer = allocbuf(len);
        for (CORBA::ULong IT_i = 0; IT_i < tempSeq._length; IT_i++) {
            _buffer[IT_i] = tempSeq._buffer[IT_i];
        }
    } else if (len < _length) {
        if (_release) {
        }
        _length = len;
    } else {
        _length = len;
    }
}

TEvent_Data_Observed_R::Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: operator [] (CORBA::ULong IT_i)  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

const TEvent_Data_Observed_R::Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: operator [] (CORBA::ULong IT_i) const  {
    if (IT_i >= _length)
        ;
    return _buffer [IT_i];
}

TEvent_Data_Observed_R::Observer_Entry* CALL_SPEC TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: allocbuf (CORBA::ULong _nelems)
{
    struct TEvent_Data_Observed_R::Observer_Entry* _pSequence = (struct TEvent_Data_Observed_R::Observer_Entry*)CORBA::_IT_vecAlloc ( sizeof ( struct TEvent_Data_Observed_R::Observer_Entry ), _nelems );
    for ( CORBA::ULong _index = 0; _index < _nelems; _index++ ) {
        (void)new ((void*)( _pSequence + _index )) struct TEvent_Data_Observed_R::Observer_Entry;
    }
    return _pSequence;
}

void CALL_SPEC TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: freebuf (TEvent_Data_Observed_R::Observer_Entry* _data)
{
    if ( _data ) {
        for ( CORBA::ULong _index = CORBA::_IT_vecNElems ( _data ); _index; _index-- ) {
            _data[ _index - 1 ].TEvent_Data_Observed_R::Observer_Entry::~Observer_Entry ();
        }
        CORBA::_IT_vecFree ( _data );
    }
}

void TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observed_R::Observer_Entry* data, CORBA::Boolean release) {
    if (_buffer && _release) {
        {
        }
        freebuf (_buffer);
    }
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

void TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: decodeInOutOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_length;
            IT_max = IT_length;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_max;
            IT_r >> IT_length;
            unsigned char IT_codeSeqElems = IT_max ? 1 : 0;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                    _buffer[IT_i].decodeInOutOp (IT_r);
                }
            }
            _length = IT_length;
            break;
        }
    }
}

void TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: encodeOp (CORBA::Request &IT_r) const {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r << _length;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r << _maximum;
            IT_r << _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].encodeOp (IT_r);
            }
            break;
        }
    }
}

void TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry:: decodeOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r >> _length;
            _maximum = _length;
            if (_maximum)
                _buffer = allocbuf (_maximum);
            else _buffer = 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i].decodeOp (IT_r);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r >> _maximum;
            IT_r >> _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            if (IT_codeSeqElems) {
                _buffer = allocbuf (_maximum);
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    _buffer[IT_i].decodeOp (IT_r);
                }
            }
            else
              _buffer = NULL;
            break;
        }
    }
}


unsigned char TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::copyHelper (const _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr* TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::_newPtr () {
    return new TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var (const _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var (_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var &TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: operator= (_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var &TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: operator= (const _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new _IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var ::~_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var::operator TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr& () { return (TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_ptr &) (_ptr);}
TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var::operator const TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_cptr& () const { return (TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_cptr &) (_ptr);}
TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var:: operator TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry& () const { return (TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry&) (* _ptr);}

const TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: in () const {
    return *_ptr;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: inOut () {
    return *_ptr;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry*& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: out () {
    return _ptr;
}

TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry* TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var :: ret () const {
    return _ptr;
}

TEvent_Data_Observed_R::Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var:: operator[] (CORBA::ULong index) {
    return (*_ptr) [index];
}

const TEvent_Data_Observed_R::Observer_Entry& TEvent_Data_Observed_R::_IDL_SEQUENCE_TEvent_Data_Observed_R_Observer_Entry_var:: operator[] (CORBA::ULong index) const {
    return (*_ptr) [index];
}


#endif

unsigned char TEvent_Data_Observed_R_var ::copyHelper (const TEvent_Data_Observed_R_var &IT_s) {
    {
        _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s._ptr);
    }
    return 1;
}

unsigned char TEvent_Data_Observed_R_var ::copyHelper (const TEvent_Data_Observed_R_mgr &IT_s) {
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s._ptr);
return 1;
}

unsigned char TEvent_Data_Observed_R_var ::copyHelper (const TEvent_Data_Observed_R_SeqElem &IT_s) {
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s);
return 1;
}

TEvent_Data_Observed_R_ptr* TEvent_Data_Observed_R_var ::_newPtr () {
    return new TEvent_Data_Observed_R_ptr;
}

TEvent_Data_Observed_R_var ::TEvent_Data_Observed_R_var (const TEvent_Data_Observed_R_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_R_var ::TEvent_Data_Observed_R_var (const TEvent_Data_Observed_R_mgr &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_R_var ::TEvent_Data_Observed_R_var (const TEvent_Data_Observed_R_SeqElem &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_R_var ::TEvent_Data_Observed_R_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = TEvent_Data_Observed_R:: _nil ();
}

TEvent_Data_Observed_R_var ::TEvent_Data_Observed_R_var (TEvent_Data_Observed_R_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Data_Observed_R_var &TEvent_Data_Observed_R_var :: operator= (TEvent_Data_Observed_R_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_R_var &TEvent_Data_Observed_R_var :: operator= (const TEvent_Data_Observed_R_var &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_R_var &TEvent_Data_Observed_R_var :: operator= (const TEvent_Data_Observed_R_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_R_var &TEvent_Data_Observed_R_var :: operator= (const TEvent_Data_Observed_R_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_R:: _duplicate (IT_s);
    return (*this);
}

TEvent_Data_Observed_R_var ::~TEvent_Data_Observed_R_var () {
    CORBA::release (_ptr);
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_var :: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_R_var::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Data_Observed_R_var::operator TEvent_Data_Observed_R_ptr& () { return (TEvent_Data_Observed_R_ptr &) (_ptr);}
TEvent_Data_Observed_R_var::operator const TEvent_Data_Observed_R_cptr& () const { return (TEvent_Data_Observed_R_cptr &) (_ptr);}

TEvent_Data_Observed_R_var ::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_var :: in () const {
    return _ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_var :: inOut () {
    return _ptr;
}

TEvent_Data_Observed_R_ptr& TEvent_Data_Observed_R_var :: out () {
    return _ptr;
}

TEvent_Data_Observed_R_ptr TEvent_Data_Observed_R_var :: ret () const {
    return _ptr;
}

void* TEvent_Data_Observed_RProxyFactoryClass::New (char *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Data_Observed_R(IT_OR);}

void* TEvent_Data_Observed_RProxyFactoryClass::New (ObjectReferenceImpl *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Data_Observed_R(IT_OR);}

void* TEvent_Data_Observed_RProxyFactoryClass::New2 () {
        return  new class TEvent_Data_Observed_R((char*)0);}

CORBA::Object* TEvent_Data_Observed_RProxyFactoryClass::NewObject (char *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Data_Observed_R*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Data_Observed_RProxyFactoryClass::NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Data_Observed_R*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Data_Observed_RProxyFactoryClass::New2Object () {
        return (CORBA::Object*)((TEvent_Data_Observed_R*)New2 ());}

void* TEvent_Data_Observed_RProxyFactoryClass::IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env) {
      void *IT_l;
      if (!CORBA::_interfaceCmp (IT_s,TEvent_Data_Observed_R_IR, IT_env))
         return IT_p;
      else if (IT_l=CORBA::ObjectFactoryClass::IT_castUp((CORBA::Object*)((class TEvent_Data_Observed_R*)IT_p),IT_s, IT_env))
         return IT_l;
      else return NULL;
    }


CORBA::PPTR* TEvent_Data_Observed_RProxyFactoryClass::pptr (void *IT_p) {
       return ((class TEvent_Data_Observed_R*)IT_p)->_pptr ();}

void TEvent_Data_Observed_RProxyFactoryClass::baseInterfaces (_IDL_SEQUENCE_string& seq) {
      add (seq, TEvent_Data_Observed_R_IR);
      CORBA::ObjectFactoryClass::baseInterfaces (seq);
}

TEvent_Data_Observed_RProxyFactoryClass TEvent_Data_Observed_RProxyFactory(1);

TEvent_Data_Observed_R::Observer_Entries* TEvent_Data_Observed_R::tevent_data_observer_list (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return NULL;
    }

    CORBA::Request IT_r (this, "_get_tevent_data_observer_list",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent_Data_Observed_R::Observer_Entries* tevent_data_observer_list;
        tevent_data_observer_list = new TEvent_Data_Observed_R::Observer_Entries;

        (*tevent_data_observer_list).decodeOp (IT_r);
        IT_r.checkEnv (IT_env);
        return tevent_data_observer_list;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

TEvent_Data_Observed_E::TEvent_Data_Observers* TEvent_Data_Observed_R::add_tevent_data_observer_list (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return NULL;
    }

    CORBA::Request IT_r (this, "_get_add_tevent_data_observer_list",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent_Data_Observed_E::TEvent_Data_Observers* add_tevent_data_observer_list;
        add_tevent_data_observer_list = new TEvent_Data_Observed_E::TEvent_Data_Observers;

        (*add_tevent_data_observer_list).decodeOp (IT_r);
        IT_r.checkEnv (IT_env);
        return add_tevent_data_observer_list;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

void TEvent_Data_Observed_R:: attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "attach_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);


            observed_id_list.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {

                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {

                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Repository_Item_Ids        )||!strcmp (IT_str, "Domain_Repository::Unknown_Repository_Item_Ids"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Repository_Item_Ids;
            ((Domain_Repository::Unknown_Repository_Item_Ids*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}

void TEvent_Data_Observed_R:: detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids, Domain_Repository::Unknown_Observer, Domain_Repository::Unmatched_Observer_Item_Ids) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "detach_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);


            observed_id_list.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {

                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {

                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Repository_Item_Ids        )||!strcmp (IT_str, "Domain_Repository::Unknown_Repository_Item_Ids"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Repository_Item_Ids;
            ((Domain_Repository::Unknown_Repository_Item_Ids*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Observer        )||!strcmp (IT_str, "Domain_Repository::Unknown_Observer"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Observer;
            ((Domain_Repository::Unknown_Observer*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Unmatched_Observer_Item_Ids        )||!strcmp (IT_str, "Domain_Repository::Unmatched_Observer_Item_Ids"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unmatched_Observer_Item_Ids;
            ((Domain_Repository::Unmatched_Observer_Item_Ids*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}

void TEvent_Data_Observed_R:: attach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "attach_add_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}

void TEvent_Data_Observed_R:: detach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "detach_add_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Observer        )||!strcmp (IT_str, "Domain_Repository::Unknown_Observer"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Observer;
            ((Domain_Repository::Unknown_Observer*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}





#ifndef TEvent_Data_Observed_R_dispatch_impl

unsigned char TEvent_Data_Observed_R_dispatch::dispatch (CORBA::Request &IT_r, 
    unsigned char, void *) {
      IT_r.makeRuntimeException1 ("TEvent_Data_Observed_R");
      return 0;
}
 
#endif

