
#ifndef tevent_rep_manager_hh
#define tevent_rep_manager_hh

#define CALL_SPEC 
#include <CORBA.h>

#include <string.h>


#include "domain_rep.hh"


#include "abng_core.hh"


#include "tevent_data_observed_e.hh"


#include "tevent.hh"


#include "tevent_data_observed_r.hh"


#include "tevent_rep.hh"


#ifndef _TEvent_Rep_Manager_defined
#define _TEvent_Rep_Manager_defined
class TEvent_Rep_Manager_dispatch : public virtual CORBA::PPTR {
public:

      TEvent_Rep_Manager_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   TEvent_Rep_Manager_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Rep_Manager_dispatch () {}

   TEvent_Rep_Manager_dispatch (ObjectReferenceImpl *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Rep_Manager_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class TEvent_Rep_Manager;

#ifndef TEvent_Rep_ManagerPtr
#define TEvent_Rep_ManagerPtr
typedef TEvent_Rep_Manager* TEvent_Rep_Manager_ptr;
typedef TEvent_Rep_Manager* TEvent_Rep_ManagerRef;
#endif

#ifndef TEvent_Rep_Manager_ptrTypedefs
#define TEvent_Rep_Manager_ptrTypedefs
typedef const TEvent_Rep_Manager* TEvent_Rep_Manager_cptr;
#endif


#ifndef TEvent_Rep_ManagerForwH
#define TEvent_Rep_ManagerForwH
CORBA::ObjectRef CALL_SPEC TEvent_Rep_Manager_getBase (void *);
void CALL_SPEC TEvent_Rep_Manager_release (TEvent_Rep_Manager *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_Rep_Manager_release (TEvent_Rep_Manager_ptr);
TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager_duplicate (TEvent_Rep_Manager_ptr, CORBA::Environment &IT_env);
TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager_duplicate (TEvent_Rep_Manager_ptr );
TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_nil (CORBA::Environment &IT_env);
TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_nil ();
#endif
#ifndef TEvent_Rep_ManagerMgrH
#define TEvent_Rep_ManagerMgrH

class TEvent_Rep_Manager_var;

class TEvent_Rep_Manager_SeqElem;

#ifndef TEvent_Rep_Manager_ptrTypedefs
#define TEvent_Rep_Manager_ptrTypedefs
typedef const TEvent_Rep_Manager* TEvent_Rep_Manager_cptr;
#endif

class TEvent_Rep_Manager_mgr : public CORBA::_mgr
{
    public:

    TEvent_Rep_Manager_mgr ();
    TEvent_Rep_Manager_mgr (const TEvent_Rep_Manager_mgr &IT_s);
    TEvent_Rep_Manager_mgr (TEvent_Rep_Manager_var IT_s);
    TEvent_Rep_Manager_mgr (const TEvent_Rep_Manager_SeqElem &IT_s);
    TEvent_Rep_Manager_mgr &operator= (TEvent_Rep_Manager_ptr IT_p);
    TEvent_Rep_Manager_mgr &operator= (const TEvent_Rep_Manager_mgr &IT_s);
    TEvent_Rep_Manager_mgr &operator= (TEvent_Rep_Manager_var IT_s);
    TEvent_Rep_Manager_mgr &operator= (const TEvent_Rep_Manager_SeqElem &IT_s);
    ~TEvent_Rep_Manager_mgr ();
    TEvent_Rep_Manager_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Rep_Manager_ptr& () ;
    operator const TEvent_Rep_Manager_ptr& () const;
    TEvent_Rep_Manager_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_Rep_Manager_ptr in () const;
    TEvent_Rep_Manager_ptr& inOut ();
    TEvent_Rep_Manager_ptr& out ();
    TEvent_Rep_Manager_ptr ret () const;
};

#endif

#ifndef TEvent_Rep_ManagerSeqElemH
#define TEvent_Rep_ManagerSeqElemH

class TEvent_Rep_Manager_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_Rep_Manager_SeqElem (TEvent_Rep_Manager_ptr* IT_p, unsigned char rel);
    TEvent_Rep_Manager_SeqElem &operator= (TEvent_Rep_Manager_ptr IT_p);
    TEvent_Rep_Manager_SeqElem &operator= (const TEvent_Rep_Manager_SeqElem &IT_s);
    TEvent_Rep_Manager_SeqElem &operator= (const TEvent_Rep_Manager_mgr &IT_s);
    TEvent_Rep_Manager_SeqElem &operator= (TEvent_Rep_Manager_var IT_s);
    operator ! () const;
    operator const TEvent_Rep_Manager_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_Rep_Manager_ptr in () const;
    TEvent_Rep_Manager_ptr& inOut ();
    TEvent_Rep_Manager_ptr& out ();
    TEvent_Rep_Manager_ptr ret () const;
    TEvent_Rep_Manager_ptr operator->() const;

    protected:
    TEvent_Rep_Manager_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_Rep_Manager_IMPL "TEvent_Rep_Manager"


class TEvent_Rep_Manager;

typedef TEvent_Rep_Manager TEvent_Rep_ManagerProxy;
#define TEvent_Rep_Manager_IR "TEvent_Rep_Manager"
#define TEvent_Rep_Manager_IMPL "TEvent_Rep_Manager"

#ifndef TEvent_Rep_ManagerPtr
#define TEvent_Rep_ManagerPtr
typedef TEvent_Rep_Manager* TEvent_Rep_Manager_ptr;
typedef TEvent_Rep_Manager* TEvent_Rep_ManagerRef;
#endif

#ifndef TEvent_Rep_Manager_ptrTypedefs
#define TEvent_Rep_Manager_ptrTypedefs
typedef const TEvent_Rep_Manager* TEvent_Rep_Manager_cptr;
#endif

class TEvent_Rep_Manager: public virtual CORBA::Object  {
public:
        TEvent_Rep_Manager (char *IT_OR);
    TEvent_Rep_Manager (ObjectReferenceImpl *IT_OR);
    TEvent_Rep_Manager () : CORBA::Object  (1) {}
protected:
    TEvent_Rep_Manager_ptr __duplicate(
            CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) {
       CORBA::Object::__duplicate (IT_env);
       return this;
    }
public:
    static TEvent_Rep_Manager_ptr CALL_SPEC _duplicate(
            TEvent_Rep_Manager_ptr, 
            CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ());
public:
   static TEvent_Rep_Manager* CALL_SPEC _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
   static TEvent_Rep_Manager* CALL_SPEC _bind (CORBA::Environment &IT_env);
   static TEvent_Rep_Manager* CALL_SPEC _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
    static TEvent_Rep_Manager* CALL_SPEC _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
private:
    static const void* IT_impl;
public:
    static TEvent_Rep_Manager_ptr CALL_SPEC  _nil (CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ()) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        return (TEvent_Rep_Manager_ptr) CORBA::OBJECT_NIL;}
    virtual TEvent_Rep_ptr rep (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
    virtual TEvents* tevent_list (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
        virtual TEvent_ptr add (const TEvent::Description& data_record, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable);
        virtual void remove (TEvent_ptr object_to_remove, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref);
        virtual void update (TEvent_ptr object_to_update, const TEvent::Description& data_record_pattern, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable);
};

#ifndef TEvent_Rep_ManagerVarH
#define TEvent_Rep_ManagerVarH

#ifndef TEvent_Rep_Manager_ptrTypedefs
#define TEvent_Rep_Manager_ptrTypedefs
typedef const TEvent_Rep_Manager* TEvent_Rep_Manager_cptr;
#endif

class TEvent_Rep_Manager_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_Rep_Manager_var &IT_s);
    unsigned char copyHelper (const TEvent_Rep_Manager_mgr &IT_s);
    unsigned char copyHelper (const TEvent_Rep_Manager_SeqElem &IT_s);

    public:

    TEvent_Rep_Manager_var (const TEvent_Rep_Manager_var &IT_s);
    TEvent_Rep_Manager_var (const TEvent_Rep_Manager_mgr &IT_s);
    TEvent_Rep_Manager_var (const TEvent_Rep_Manager_SeqElem &IT_s);
    TEvent_Rep_Manager_var ();
    TEvent_Rep_Manager_var (TEvent_Rep_Manager_ptr IT_p);
    TEvent_Rep_Manager_var &operator= (TEvent_Rep_Manager_ptr IT_p);
    TEvent_Rep_Manager_var &operator= (const TEvent_Rep_Manager_var &IT_s);
    TEvent_Rep_Manager_var &operator= (const TEvent_Rep_Manager_mgr &IT_s);
    TEvent_Rep_Manager_var &operator= (const TEvent_Rep_Manager_SeqElem &IT_s);
    ~TEvent_Rep_Manager_var ();
    TEvent_Rep_Manager_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Rep_Manager_ptr& () ;
    operator const TEvent_Rep_Manager_cptr& () const;

    operator CORBA::Object_ptr () const;
    TEvent_Rep_Manager_ptr in () const;
    TEvent_Rep_Manager_ptr& inOut ();
    TEvent_Rep_Manager_ptr& out ();
    TEvent_Rep_Manager_ptr ret () const;
    protected:
    TEvent_Rep_Manager_ptr* _indPtr;
    TEvent_Rep_Manager_ptr& _ptr;
    private:
    static TEvent_Rep_Manager_ptr* _newPtr ();
    TEvent_Rep_Manager_var &operator= (const CORBA::_var &IT_s);
    TEvent_Rep_Manager_var (const CORBA::_var &IT_s);
};

#endif



#define TIE_TEvent_Rep_Manager(X) TEvent_Rep_Manager##X

#define DEF_TIE_TEvent_Rep_Manager(X) \
	class TEvent_Rep_Manager##X : public virtual TEvent_Rep_Manager {		\
	  X* m_obj;						\
	public:							\
								\
								\
	   TEvent_Rep_Manager##X  (X *objp, const char* m="", CORBA::LoaderClass *l=0)\
		: TEvent_Rep_Manager(), m_obj(objp) {	\
		m_pptr = new TEvent_Rep_Manager_dispatch		\
			(( TEvent_Rep_Manager*)this,(CORBA::Object*)this,m,l,TEvent_Rep_Manager_IR,m_obj);	\
	   }								\
	   TEvent_Rep_Manager##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=0)\
		: TEvent_Rep_Manager() {	\
		m_pptr = new TEvent_Rep_Manager_dispatch		\
			(( TEvent_Rep_Manager*)this,(CORBA::Object*)this,IT_m,TEvent_Rep_Manager_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~TEvent_Rep_Manager##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
virtual TEvent_Rep_ptr rep (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->rep(IT_env); \
}\
	\
virtual TEvents* tevent_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_list(IT_env); \
}\
	\
virtual TEvent_ptr add (const TEvent::Description& data_record, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable){\
return m_obj->add (  data_record,IT_env);\
}\
	\
virtual void remove (TEvent_ptr object_to_remove, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref){\
m_obj->remove (  object_to_remove,IT_env);\
}\
	\
virtual void update (TEvent_ptr object_to_update, const TEvent::Description& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable){\
m_obj->update (  object_to_update,  data_record_pattern,IT_env);\
}\
								\
	};						\


#define QUALS_TEvent_Rep_Manager	\
virtual TEvent_Rep_ptr rep (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->rep(IT_env); \
}\
	\
virtual TEvents* tevent_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_list(IT_env); \
}\
	\
virtual TEvent_ptr add (const TEvent::Description& data_record, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable){\
return m_obj->add (  data_record,IT_env);\
}\
	\
virtual void remove (TEvent_ptr object_to_remove, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref){\
m_obj->remove (  object_to_remove,IT_env);\
}\
	\
virtual void update (TEvent_ptr object_to_update, const TEvent::Description& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable){\
m_obj->update (  object_to_update,  data_record_pattern,IT_env);\
}\




class TEvent_Rep_ManagerProxyFactoryClass : public virtual CORBA::ObjectFactoryClass {
public:
   TEvent_Rep_ManagerProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (TEvent_Rep_Manager_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual CORBA::Object* NewObject (char *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* New2Object (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

extern TEvent_Rep_ManagerProxyFactoryClass TEvent_Rep_ManagerProxyFactory;

#endif


#endif
