
#include "tevent_rep_manager.hh"

TEvent_Rep_Manager_mgr::TEvent_Rep_Manager_mgr () 
{
    _ptr = TEvent_Rep_Manager:: _nil ();
}

TEvent_Rep_Manager_mgr::TEvent_Rep_Manager_mgr (const TEvent_Rep_Manager_mgr &IT_s) 
{
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s._ptr);
}

TEvent_Rep_Manager_mgr::TEvent_Rep_Manager_mgr (TEvent_Rep_Manager_var IT_s) 
{
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s);
}

TEvent_Rep_Manager_mgr::TEvent_Rep_Manager_mgr (const TEvent_Rep_Manager_SeqElem &IT_s) 
{
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s);
}

TEvent_Rep_Manager_mgr &TEvent_Rep_Manager_mgr::operator= (TEvent_Rep_Manager_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Rep_Manager_mgr &TEvent_Rep_Manager_mgr::operator= (const TEvent_Rep_Manager_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate(IT_s._ptr);
    return (*this);
}

TEvent_Rep_Manager_mgr &TEvent_Rep_Manager_mgr::operator= (TEvent_Rep_Manager_var IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate(IT_s);
    return (*this);
}

TEvent_Rep_Manager_mgr &TEvent_Rep_Manager_mgr::operator= (const TEvent_Rep_Manager_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate(IT_s);
    return (*this);
}

TEvent_Rep_Manager_mgr::~TEvent_Rep_Manager_mgr () {
    CORBA::release (_ptr);
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_mgr:: operator-> () const {
    return _ptr;
}

TEvent_Rep_Manager_mgr::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Rep_Manager_mgr::operator TEvent_Rep_Manager_ptr& () { return (TEvent_Rep_Manager_ptr &) (_ptr);}
TEvent_Rep_Manager_mgr::operator const TEvent_Rep_Manager_ptr& () const { return (TEvent_Rep_Manager_ptr &) (_ptr);}

TEvent_Rep_Manager_mgr::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_mgr:: in () const {
    return _ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_mgr:: inOut () {
    return _ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_mgr:: out () {
    return _ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_mgr:: ret () const {
    return _ptr;
}

TEvent_Rep_Manager_SeqElem::TEvent_Rep_Manager_SeqElem (TEvent_Rep_Manager_ptr* IT_p, unsigned char rel) {
    _ptr = IT_p;
    _release = rel;
}

TEvent_Rep_Manager_SeqElem &TEvent_Rep_Manager_SeqElem::operator= (TEvent_Rep_Manager_ptr IT_p) {
    if (_ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = IT_p;
    }
    return (*this);
}

TEvent_Rep_Manager_SeqElem &TEvent_Rep_Manager_SeqElem::operator= (const TEvent_Rep_Manager_SeqElem &IT_s) {
    if (_ptr && IT_s._ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep_Manager:: _duplicate(*(IT_s._ptr));
    }
    return (*this);
}

TEvent_Rep_Manager_SeqElem &TEvent_Rep_Manager_SeqElem::operator= (const TEvent_Rep_Manager_mgr &IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep_Manager:: _duplicate(IT_s._ptr);
    }
    return (*this);
}

TEvent_Rep_Manager_SeqElem &TEvent_Rep_Manager_SeqElem::operator= (TEvent_Rep_Manager_var IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep_Manager:: _duplicate (IT_s);
    }
    return (*this);
}

TEvent_Rep_Manager_SeqElem::operator ! () const {
    return ((CORBA::is_nil (*_ptr)));
}

TEvent_Rep_Manager_SeqElem::operator const TEvent_Rep_Manager_ptr& () const { return (TEvent_Rep_Manager_ptr &) (*_ptr);}

TEvent_Rep_Manager_SeqElem::operator CORBA::Object_ptr () const {
    return *_ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_SeqElem:: in () const {
    return *_ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_SeqElem:: inOut () {
    return *_ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_SeqElem:: out () {
    return *_ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_SeqElem:: ret () const {
    return *_ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_SeqElem::operator->() const { return *_ptr;}

TEvent_Rep_Manager::TEvent_Rep_Manager (char *IT_OR) {
      m_pptr = new TEvent_Rep_Manager_dispatch (IT_OR, this,(CORBA::Object*)this);
} 
TEvent_Rep_Manager::TEvent_Rep_Manager (ObjectReferenceImpl *IT_OR) {
      m_pptr = new TEvent_Rep_Manager_dispatch (IT_OR, this,(CORBA::Object*)this);
} 

#ifndef TEvent_Rep_ManagerForwC
#define TEvent_Rep_ManagerForwC
CORBA::ObjectRef CALL_SPEC TEvent_Rep_Manager_getBase(void *IT_p){
    return (TEvent_Rep_Manager*) IT_p;}

void CALL_SPEC TEvent_Rep_Manager_release (TEvent_Rep_Manager_ptr IT_p, CORBA::Environment &IT_env) {
    CORBA::release(IT_p, IT_env);}

void CALL_SPEC TEvent_Rep_Manager_release (TEvent_Rep_Manager_ptr IT_p) {
    TEvent_Rep_Manager_release (IT_p, CORBA::IT_chooseDefaultEnv ()); }

TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_nil (CORBA::Environment &) {
    return TEvent_Rep_Manager:: _nil ();}

TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_nil () {
    return TEvent_Rep_Manager_nil (CORBA::IT_chooseDefaultEnv ());}

TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_duplicate (TEvent_Rep_Manager_ptr IT_p, CORBA::Environment &IT_env) {
    return (TEvent_Rep_Manager::_duplicate(IT_p, IT_env)); }
TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager_duplicate (TEvent_Rep_Manager_ptr IT_p) {
    return TEvent_Rep_Manager_duplicate (IT_p, CORBA::IT_chooseDefaultEnv ()); }
#endif

TEvent_Rep_Manager_ptr CALL_SPEC TEvent_Rep_Manager::_duplicate(TEvent_Rep_Manager_ptr obj, CORBA::Environment& IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
       if (!obj) {
          return (obj);
       }
       TEvent_Rep_Manager_ptr IT_obj = obj->__duplicate (IT_env);
       return IT_obj;
}



TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager:: _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env) {
       return (TEvent_Rep_Manager*)CORBA::Factory.New (IT_markerServer, IT_env, IT_c, host, 
		TEvent_Rep_Manager_IMPL, TEvent_Rep_Manager_IR);
}



TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager:: _bind (CORBA::Environment &IT_env) {
       return _bind (NULL,NULL,CORBA::Context(), IT_env); }


TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager:: _bind (const char* IT_markerServer, const char* host,
                CORBA::Environment &IT_env) {
       return _bind (IT_markerServer, host, CORBA::Context (), IT_env); }
TEvent_Rep_Manager* CALL_SPEC TEvent_Rep_Manager::_narrow (CORBA::Object* IT_obj, CORBA::Environment &IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        if (CORBA::is_nil (IT_obj)) {
                return TEvent_Rep_Manager:: _nil();
        }

       TEvent_Rep_Manager* IT_p = (TEvent_Rep_Manager*)CORBA::Object::_castDown (IT_obj, TEvent_Rep_Manager_IR, IT_env);
        IT_p = IT_p ? IT_p->__duplicate(IT_env) : NULL;
        if ((IT_env) &&(!strcmp(IT_env.exception()->id(), "CORBA::StExcep::BAD_PARAM")) && (((CORBA::BAD_PARAM*)IT_env.exception())-> minor() == NARROW_FAILED)) {
                IT_env.exception_free();
        }
        return IT_p;
   }

const void* TEvent_Rep_Manager:: IT_impl = CORBA::IT_implTable.record (TEvent_Rep_Manager_IMPL, "IDL:TEvent_Rep_Manager:1.0");

unsigned char TEvent_Rep_Manager_var ::copyHelper (const TEvent_Rep_Manager_var &IT_s) {
    {
        _ptr = TEvent_Rep_Manager:: _duplicate (IT_s._ptr);
    }
    return 1;
}

unsigned char TEvent_Rep_Manager_var ::copyHelper (const TEvent_Rep_Manager_mgr &IT_s) {
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s._ptr);
return 1;
}

unsigned char TEvent_Rep_Manager_var ::copyHelper (const TEvent_Rep_Manager_SeqElem &IT_s) {
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s);
return 1;
}

TEvent_Rep_Manager_ptr* TEvent_Rep_Manager_var ::_newPtr () {
    return new TEvent_Rep_Manager_ptr;
}

TEvent_Rep_Manager_var ::TEvent_Rep_Manager_var (const TEvent_Rep_Manager_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_Manager_var ::TEvent_Rep_Manager_var (const TEvent_Rep_Manager_mgr &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_Manager_var ::TEvent_Rep_Manager_var (const TEvent_Rep_Manager_SeqElem &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_Manager_var ::TEvent_Rep_Manager_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = TEvent_Rep_Manager:: _nil ();
}

TEvent_Rep_Manager_var ::TEvent_Rep_Manager_var (TEvent_Rep_Manager_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Rep_Manager_var &TEvent_Rep_Manager_var :: operator= (TEvent_Rep_Manager_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Rep_Manager_var &TEvent_Rep_Manager_var :: operator= (const TEvent_Rep_Manager_var &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Rep_Manager_var &TEvent_Rep_Manager_var :: operator= (const TEvent_Rep_Manager_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Rep_Manager_var &TEvent_Rep_Manager_var :: operator= (const TEvent_Rep_Manager_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep_Manager:: _duplicate (IT_s);
    return (*this);
}

TEvent_Rep_Manager_var ::~TEvent_Rep_Manager_var () {
    CORBA::release (_ptr);
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_var :: operator-> () const {
    return _ptr;
}

TEvent_Rep_Manager_var::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Rep_Manager_var::operator TEvent_Rep_Manager_ptr& () { return (TEvent_Rep_Manager_ptr &) (_ptr);}
TEvent_Rep_Manager_var::operator const TEvent_Rep_Manager_cptr& () const { return (TEvent_Rep_Manager_cptr &) (_ptr);}

TEvent_Rep_Manager_var ::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_var :: in () const {
    return _ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_var :: inOut () {
    return _ptr;
}

TEvent_Rep_Manager_ptr& TEvent_Rep_Manager_var :: out () {
    return _ptr;
}

TEvent_Rep_Manager_ptr TEvent_Rep_Manager_var :: ret () const {
    return _ptr;
}

void* TEvent_Rep_ManagerProxyFactoryClass::New (char *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Rep_Manager(IT_OR);}

void* TEvent_Rep_ManagerProxyFactoryClass::New (ObjectReferenceImpl *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Rep_Manager(IT_OR);}

void* TEvent_Rep_ManagerProxyFactoryClass::New2 () {
        return  new class TEvent_Rep_Manager((char*)0);}

CORBA::Object* TEvent_Rep_ManagerProxyFactoryClass::NewObject (char *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Rep_Manager*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Rep_ManagerProxyFactoryClass::NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Rep_Manager*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Rep_ManagerProxyFactoryClass::New2Object () {
        return (CORBA::Object*)((TEvent_Rep_Manager*)New2 ());}

void* TEvent_Rep_ManagerProxyFactoryClass::IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env) {
      void *IT_l;
      if (!CORBA::_interfaceCmp (IT_s,TEvent_Rep_Manager_IR, IT_env))
         return IT_p;
      else if (IT_l=CORBA::ObjectFactoryClass::IT_castUp((CORBA::Object*)((class TEvent_Rep_Manager*)IT_p),IT_s, IT_env))
         return IT_l;
      else return NULL;
    }


CORBA::PPTR* TEvent_Rep_ManagerProxyFactoryClass::pptr (void *IT_p) {
       return ((class TEvent_Rep_Manager*)IT_p)->_pptr ();}

void TEvent_Rep_ManagerProxyFactoryClass::baseInterfaces (_IDL_SEQUENCE_string& seq) {
      add (seq, TEvent_Rep_Manager_IR);
      CORBA::ObjectFactoryClass::baseInterfaces (seq);
}

TEvent_Rep_ManagerProxyFactoryClass TEvent_Rep_ManagerProxyFactory(1);

TEvent_Rep_ptr TEvent_Rep_Manager::rep (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return new TEvent_Rep;
    }

    CORBA::Request IT_r (this, "_get_rep",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent_Rep_ptr rep;

        rep = (TEvent_Rep*) IT_r.decodeObjRef (TEvent_Rep_IR);
        IT_r.checkEnv (IT_env);
        return rep;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return new TEvent_Rep;
}

TEvents* TEvent_Rep_Manager::tevent_list (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return NULL;
    }

    CORBA::Request IT_r (this, "_get_tevent_list",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvents* tevent_list;
        tevent_list = new TEvents;

        (*tevent_list).decodeOp (IT_r);
        IT_r.checkEnv (IT_env);
        return tevent_list;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

TEvent_ptr TEvent_Rep_Manager:: add (const TEvent::Description& data_record, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return new TEvent;
    }
    CORBA::Request IT_r (this, "add",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            data_record.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                TEvent_ptr IT_result;
                IT_result = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                TEvent_ptr IT_result;
                IT_result = (TEvent*) IT_r.decodeObjRef (TEvent_IR);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Duplicate_Data_Record        )||!strcmp (IT_str, "Domain_Repository::Duplicate_Data_Record"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Duplicate_Data_Record;
            ((Domain_Repository::Duplicate_Data_Record*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Invalid_Description        )||!strcmp (IT_str, "Domain_Repository::Invalid_Description"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Invalid_Description;
            ((Domain_Repository::Invalid_Description*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return new TEvent;
}

void TEvent_Rep_Manager:: remove (TEvent_ptr object_to_remove, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "remove",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            {
                CORBA::Object* IT_l0 = (CORBA::Object*) object_to_remove;
                IT_r << IT_l0;
            }
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Object_Ref        )||!strcmp (IT_str, "Domain_Repository::Unknown_Object_Ref"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Object_Ref;
            ((Domain_Repository::Unknown_Object_Ref*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}

void TEvent_Rep_Manager:: update (TEvent_ptr object_to_update, const TEvent::Description& data_record_pattern, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Object_Ref, Domain_Repository::Duplicate_Data_Record, Domain_Repository::Invalid_Description, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "update",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            {
                CORBA::Object* IT_l0 = (CORBA::Object*) object_to_update;
                IT_r << IT_l0;
            }


            data_record_pattern.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {

                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {

                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Object_Ref        )||!strcmp (IT_str, "Domain_Repository::Unknown_Object_Ref"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Object_Ref;
            ((Domain_Repository::Unknown_Object_Ref*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Duplicate_Data_Record        )||!strcmp (IT_str, "Domain_Repository::Duplicate_Data_Record"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Duplicate_Data_Record;
            ((Domain_Repository::Duplicate_Data_Record*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Invalid_Description        )||!strcmp (IT_str, "Domain_Repository::Invalid_Description"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Invalid_Description;
            ((Domain_Repository::Invalid_Description*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}





#ifndef TEvent_Rep_Manager_dispatch_impl

unsigned char TEvent_Rep_Manager_dispatch::dispatch (CORBA::Request &IT_r, 
    unsigned char, void *) {
      IT_r.makeRuntimeException1 ("TEvent_Rep_Manager");
      return 0;
}
 
#endif

