// $Id: compatibility.hh,v 1.2 1998/06/16 12:56:04 mencnar Exp $
//
// $Log: compatibility.hh,v $
// Revision 1.2  1998/06/16 12:56:04  mencnar
// *** empty log message ***
//
// Revision 1.1  1998/03/02 15:09:58  mencnar
// Initial revision
//
//

#ifndef __compatibility_hh__
#define __compatibility_hh__

#ifdef ORBIX
#define ENV_DECL( env) ,CORBA::Environment &env= CORBA::default_environment
#define ENV_DEF( env) ,CORBA::Environment &env
#define ENV_DECL1( env) CORBA::Environment &env= CORBA::default_environment
#define ENV_DEF1( env) CORBA::Environment &env
#define USE_ENV1( env) env
#define USE_ENV(env) ,env
#define ORB_IDENTIFIER "Orbix"
#define BOA_IDENTIFIER "Orbix_BOA"
#define BOA_IMPL_BASE(SCOPE,INTERFACE) SCOPE::##INTERFACE##BOAImpl
#define MY_PRINCIPAL_VAR CORBA::Principal_var
#define CONNECT_IMPL(varType,obj)
#define DISCONNECT_IMPL(varType,obj)

CORBA::Boolean DII_non_existent( CORBA::Object_ptr obj);

#else

#define ENV_DECL( env)
#define ENV_DEF( env)
#define ENV_DECL1( env)
#define ENV_DEF1( env)
#define USE_ENV( env)
#define USE_ENV1( env)
#define ORB_IDENTIFIER "omniORB2"
#define BOA_IDENTIFIER "omniORB2_BOA"
#define BOA_IMPL_BASE(SCOPE,INTERFACE) SCOPE::_sk_##INTERFACE
//#define TIE_CLASS(SCOPE,INTERFACE) _tie_##INTERFACE
#define TIE_CLASS(SCOPE,INTERFACE) _tie_##SCOPE##_##INTERFACE
#define MY_PRINCIPAL_VAR omniORB_Principal_var

#define CONNECT_IMPL(varType,obj) \
  { CORBA::BOA::getBOA()->obj_is_ready( obj); \
  } 
  
#define DISCONNECT_IMPL(varType,obj) \
  { CORBA::BOA::getBOA()->dispose( obj); \
  }
 
class omniORB_Principal_var {
};

ostream & operator <<( ostream &os, CORBA::Exception &ex);

void serialize_TypeCode( ostream &ostr, CORBA::TypeCode_ptr tc);
void deserialize_TypeCode( istream &istr, CORBA::TypeCode_ptr &tc);

#endif


#endif //

//
