#ifndef _DREP_TYPES
#define _DREP_TYPES 1


#define DEF_TYPE(XX)                                                         \
class XX##_Types {                                                           \
public:                                                                      \
  typedef Domain_Repository::XX Item;                                        \
  typedef Domain_Repository::XX##_ptr Item_ptr;                              \
  typedef Domain_Repository::XX##s Items;                          \
  typedef Domain_Repository::XX::Description Initial_Data;                   \
  typedef Domain_Repository::XX##_Rep Repository;                            \
  typedef Domain_Repository::XX##_Rep_ptr Repository_ptr;                    \
                                                                             \
  static Domain_Repository::XX::Pattern init_pattern();                      \
};                                                                           \
                                                                             \
ostream& operator << (ostream&, Domain_Repository::XX::Value_Description&);

DEF_TYPE(Location_Type)
DEF_TYPE(Location_Description)
DEF_TYPE(Meta_Equipment)
DEF_TYPE(Equipment)
DEF_TYPE(User)

#ifdef ORBIX
ostream& operator<< (ostream&, CORBA::any&);
#else
ostream& operator<< (ostream&, CORBA::Any&);
#endif


#endif _DREP_TYPES
