// -*- Mode: C++; -*-
//
// $Id: ORB_wrapper_vbroker.java,v 1.1.1.1 1998/07/03 13:04:42 mencnar Exp $
//
// $Log: ORB_wrapper_vbroker.java,v $
// Revision 1.1.1.1  1998/07/03 13:04:42  mencnar
//
//
package pl.edu.agh.ics.abngcore;

public class ORB_wrapper_vbroker extends ORB_wrapper {
  org.omg.CORBA.ORB orb= null;
  org.omg.CORBA.BOA my_boa= null;

  public void init_application( String argv[] ) {
    orb= org.omg.CORBA.ORB.init( argv, null);
    my_boa= orb.BOA_init(); 
  }

  public void connect_object( org.omg.CORBA.Object obj) {
    my_boa.obj_is_ready( obj);
  }

  public void disconnect_object( org.omg.CORBA.Object obj) {
    my_boa.deactivate_obj( obj);
  }

  public void impl_is_ready( ) {
    my_boa.impl_is_ready();
  }

  public void call_static_notify(
	Domain_Repository.Static_Data_Observer obs,
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {

    obs.notify( item_id, obj, change);
  }


  public ORB_wrapper_vbroker() {
  }
}




