#include "abng_ld_rep_server.h"

void ABng_LD_Rep_Server::create_objects() {

  my_sensor_observer = new Sensor_Observer_I();
  my_location_descr_observer = new Location_Descr_Observer_I();
  my_rep_i = new ABng_Loc_Descr_Rep_I(file_name);
  my_rep_i->init(cold_start);
}

void ABng_LD_Rep_Server::delete_objects() {

  delete my_rep_i;
  delete my_sensor_observer;
  delete my_location_descr_observer;
}
