//
//  File:         badge_holder_rep_main.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 06.02.98
//
// General Description:
//   Main file for the badge_holder_rep server
//
// The executable file generated from this code should be registered 
// (under the name 'badge_holder_rep') using the 'putit' command.
//

#ifdef ORBIX
#define USE_IIOP
#define USE_IR
#endif

#include "badge_holder_rep_server.h"

int main(int argc,  char **argv) 
{
	Badge_Holder_Rep_Server my_badge_holder_rep_server;

	my_badge_holder_rep_server.init(argc, argv);
	my_badge_holder_rep_server.run();
	my_badge_holder_rep_server.final();
}
