#ifndef __BADGE_REP_SERVER_H__
#define __BADGE_REP_SERVER_H__ 1

#include "rep_server.h"
#include "badge_rep_i.hh"

class Badge_Rep_Server : public Rep_Server {

public:

  Badge_Rep_Server(
#ifdef ObjectStore
    const char *db_name_p = "dbName",
#elif FilePersistency
    const char *file_name_p = "Badge_Rep.db",
#endif
    const char *current_directory_p = ".") : Rep_Server(
#ifdef ObjectStore
    db_name_p,
#elif FilePersistency
    file_name_p,
#endif
    current_directory_p) {}

  virtual ~Badge_Rep_Server() {}

  virtual void create_objects();
  virtual void delete_objects();

protected:
  Badge_Rep_I *my_rep_i;
};

#endif // __BADGE_REP_SERVER_H__

//





