// $Id: sched_stat.cc,v 1.1 1998/06/18 10:21:56 mencnar Exp $
//
// $Log: sched_stat.cc,v $
// Revision 1.1  1998/06/18 10:21:56  mencnar
// Initial revision
//
//

#include "sched_main.hh"
#include "sched_stat.hh"



void Sched_Stat::inc_subrequest_counter() {
  auto_lock( *this);
  subrequest_counter++;
}

void Sched_Stat::inc_command_sent_counter() {
  auto_lock( *this);
  command_sent_counter++;
}

void Sched_Stat::inc_reply_counter() {
  auto_lock( *this);
  reply_counter++;
}

void Sched_Stat::inc_sighting_errors_counter() {
  auto_lock( *this);
  sighting_errors_counter++;
}

void Sched_Stat::inc_reply_errors_counter() {
  auto_lock( *this);
  reply_errors_counter++;
}

int Sched_Stat::get_subrequest_counter() {
  auto_lock( *this);
  return subrequest_counter;
}

int Sched_Stat::get_command_sent_counter() {
  auto_lock( *this);
  return command_sent_counter;
}

int Sched_Stat::get_reply_counter() {
  auto_lock( *this);
  return reply_counter;
}

int Sched_Stat::get_sighting_errors_counter() {
  auto_lock( *this);
  return sighting_errors_counter;
}

int Sched_Stat::get_reply_errors_counter() {
  auto_lock( *this);
  return reply_errors_counter;
}

Sched_Stat sched_stat;

