// $Id: sched_stat.hh,v 1.2 1998/06/18 10:21:56 mencnar Exp $
// 
// $Log: sched_stat.hh,v $
// Revision 1.2  1998/06/18 10:21:56  mencnar
// moved to CVS
//
// Revision 1.1  1997/11/05 14:11:21  mencnar
// Initial revision
//
//

class Sched_Stat : ABng_Guarded {
  int subrequest_counter;
  int command_sent_counter;
  int reply_counter;
  int sighting_errors_counter;
  int reply_errors_counter;
public:
  void inc_subrequest_counter();
  void inc_command_sent_counter();
  void inc_reply_counter();
  void inc_sighting_errors_counter();
  void inc_reply_errors_counter();

  int get_subrequest_counter();
  int get_command_sent_counter();
  int get_reply_counter();
  int get_sighting_errors_counter();
  int get_reply_errors_counter();
};

extern Sched_Stat sched_stat;



