// $Id: comparable_badge_id.cc,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/comparable_badge_id.cc,v $
//
// $Log: comparable_badge_id.cc,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:35:18  jasz
// Initial revision
//
//
// File:          comparable_badge_descr.cc
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Definition of the Comparable_Badge_Id class. It encapsulates badge id
//  and provides an equality testing operator.

#include "comparable_badge_id.h"

unsigned Comparable_Badge_Id::hash(const Comparable_Badge_Id& bid) {

  unsigned res = 0;
  for(unsigned i = 0; i < bid.length(); i++) {
    res = (res << 8) | bid[i];
  }
  return res;
}

int Comparable_Badge_Id::operator==(const Comparable_Badge_Id& bid) {

  if(length() != bid.length()) {
    return 0;
  }
  for(unsigned i = 0; i < bid.length() && (*this)[i] == bid[i]; i++);
  if(i == bid.length()) {
    return 1;
    }
  return 0;
}
