// $Id: comparable_badge_id.h,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/comparable_badge_id.h,v $
//
// $Log: comparable_badge_id.h,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:46:16  jasz
// Initial revision
//
//
// File:          comparable_badge_descr.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Declaration of the Comparable_Badge_Id class. It encapsulates badge id
//  and provides an equality testing operator.

#ifndef __COMPARABLE_BADGE_ID_H__
#define __COMPARABLE_BADGE_ID_H__

#include "abng_core_management.hh"

class Comparable_Badge_Id : public ABng_Core_System::Badge_Id {

public:

  Comparable_Badge_Id() {}
  Comparable_Badge_Id(const ABng_Core_System::Badge_Id& bid) {
    *((ABng_Core_System::Badge_Id*) this) = bid;
  }
  virtual int operator==(const Comparable_Badge_Id& bid);
  static unsigned hash(const Comparable_Badge_Id& bid);
};

#endif /* __COMPARABLE_BADGE_ID_H__ */
