//
//  File:         user_rep_client.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 27.05.98
//
// General Description:
//   Implementation file for the class of a client of the User 
//	 Repository interface
//

#include "user_rep_client.h"

extern "C"      int isalpha(int c);
extern "C"      int isdigit(int c);


User_Rep_Client::Operations Rep_Client<User_Types_Mgr>::operations = 
  {{0, {0}}};

char* Rep_Client<User_Types_Mgr>::description = 
"\"uid(identifier) forename(identifier) surname(identifier) position(identifier) email(identifier) phone(identifier)\"";

Domain_Repository::User::Description 
   User_Rep_Client::init_data (
	char* data
   ) 
{
	Domain_Repository::User::Description d;

	d.uid      = read_id(data);
	d.forename = read_id(data);
	d.surname  = read_id(data);
	d.position  = read_id(data);
	d.email  = read_id(data);
	d.phone  = read_id(data);

	return d;
}







