
#ifndef tevent_data_observer_hh
#define tevent_data_observer_hh

#define CALL_SPEC 
#include <CORBA.h>

#include <string.h>


#include "domain_rep.hh"


#include "abng_core.hh"


#include "tevent_data_observed_e.hh"


#include "tevent.hh"


#ifndef _TEvent_Data_Observer_defined
#define _TEvent_Data_Observer_defined
class TEvent_Data_Observer_dispatch : public virtual CORBA::PPTR {
public:

      TEvent_Data_Observer_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   TEvent_Data_Observer_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Data_Observer_dispatch () {}

   TEvent_Data_Observer_dispatch (ObjectReferenceImpl *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Data_Observer_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class TEvent_Data_Observer;

#ifndef TEvent_Data_ObserverPtr
#define TEvent_Data_ObserverPtr
typedef TEvent_Data_Observer* TEvent_Data_Observer_ptr;
typedef TEvent_Data_Observer* TEvent_Data_ObserverRef;
#endif

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif


#ifndef TEvent_Data_ObserverForwH
#define TEvent_Data_ObserverForwH
CORBA::ObjectRef CALL_SPEC TEvent_Data_Observer_getBase (void *);
void CALL_SPEC TEvent_Data_Observer_release (TEvent_Data_Observer *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_Data_Observer_release (TEvent_Data_Observer_ptr);
TEvent_Data_Observer* CALL_SPEC TEvent_Data_Observer_duplicate (TEvent_Data_Observer_ptr, CORBA::Environment &IT_env);
TEvent_Data_Observer* CALL_SPEC TEvent_Data_Observer_duplicate (TEvent_Data_Observer_ptr );
TEvent_Data_Observer_ptr CALL_SPEC TEvent_Data_Observer_nil (CORBA::Environment &IT_env);
TEvent_Data_Observer_ptr CALL_SPEC TEvent_Data_Observer_nil ();
#endif
#ifndef TEvent_Data_ObserverMgrH
#define TEvent_Data_ObserverMgrH

class TEvent_Data_Observer_var;

class TEvent_Data_Observer_SeqElem;

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif

class TEvent_Data_Observer_mgr : public CORBA::_mgr
{
    public:

    TEvent_Data_Observer_mgr ();
    TEvent_Data_Observer_mgr (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_mgr (TEvent_Data_Observer_var IT_s);
    TEvent_Data_Observer_mgr (const TEvent_Data_Observer_SeqElem &IT_s);
    TEvent_Data_Observer_mgr &operator= (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_mgr &operator= (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_mgr &operator= (TEvent_Data_Observer_var IT_s);
    TEvent_Data_Observer_mgr &operator= (const TEvent_Data_Observer_SeqElem &IT_s);
    ~TEvent_Data_Observer_mgr ();
    TEvent_Data_Observer_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Observer_ptr& () ;
    operator const TEvent_Data_Observer_ptr& () const;
    TEvent_Data_Observer_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_Data_Observer_ptr in () const;
    TEvent_Data_Observer_ptr& inOut ();
    TEvent_Data_Observer_ptr& out ();
    TEvent_Data_Observer_ptr ret () const;
};

#endif

#ifndef TEvent_Data_ObserverSeqElemH
#define TEvent_Data_ObserverSeqElemH

class TEvent_Data_Observer_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_Data_Observer_SeqElem (TEvent_Data_Observer_ptr* IT_p, unsigned char rel);
    TEvent_Data_Observer_SeqElem &operator= (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_SeqElem &operator= (const TEvent_Data_Observer_SeqElem &IT_s);
    TEvent_Data_Observer_SeqElem &operator= (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_SeqElem &operator= (TEvent_Data_Observer_var IT_s);
    operator ! () const;
    operator const TEvent_Data_Observer_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_Data_Observer_ptr in () const;
    TEvent_Data_Observer_ptr& inOut ();
    TEvent_Data_Observer_ptr& out ();
    TEvent_Data_Observer_ptr ret () const;
    TEvent_Data_Observer_ptr operator->() const;

    protected:
    TEvent_Data_Observer_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_Data_Observer_IMPL "TEvent_Data_Observer"


class TEvent_Data_Observer;

typedef TEvent_Data_Observer TEvent_Data_ObserverProxy;
#define TEvent_Data_Observer_IR "TEvent_Data_Observer"
#define TEvent_Data_Observer_IMPL "TEvent_Data_Observer"

#ifndef TEvent_Data_ObserverPtr
#define TEvent_Data_ObserverPtr
typedef TEvent_Data_Observer* TEvent_Data_Observer_ptr;
typedef TEvent_Data_Observer* TEvent_Data_ObserverRef;
#endif

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif

class TEvent_Data_Observer: public virtual CORBA::Object  {
public:
        TEvent_Data_Observer (char *IT_OR);
    TEvent_Data_Observer (ObjectReferenceImpl *IT_OR);
    TEvent_Data_Observer () : CORBA::Object  (1) {}
protected:
    TEvent_Data_Observer_ptr __duplicate(
            CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) {
       CORBA::Object::__duplicate (IT_env);
       return this;
    }
public:
    static TEvent_Data_Observer_ptr CALL_SPEC _duplicate(
            TEvent_Data_Observer_ptr, 
            CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ());
public:
   static TEvent_Data_Observer* CALL_SPEC _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
   static TEvent_Data_Observer* CALL_SPEC _bind (CORBA::Environment &IT_env);
   static TEvent_Data_Observer* CALL_SPEC _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
    static TEvent_Data_Observer* CALL_SPEC _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
private:
    static const void* IT_impl;
public:
    static TEvent_Data_Observer_ptr CALL_SPEC  _nil (CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ()) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        return (TEvent_Data_Observer_ptr) CORBA::OBJECT_NIL;}

#ifndef TEvent_Data_Observer_TEvent_Data_Object_defined
#define TEvent_Data_Observer_TEvent_Data_Object_defined

struct TEvent_Data_Object {
    TEvent_mgr tevent_obj;
    TEvent::StateMsg msg;
    CORBA::Boolean state;

    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
    TEvent_Data_Object(const TEvent_Data_Object &);
    TEvent_Data_Object();
    ~TEvent_Data_Object();
    TEvent_Data_Object& operator= (const TEvent_Data_Object&);
};

#ifndef TEvent_Data_Observer_TEvent_Data_ObjectVarH
#define TEvent_Data_Observer_TEvent_Data_ObjectVarH

#ifndef TEvent_Data_Observer_TEvent_Data_Object_ptrTypedefsNC
#define TEvent_Data_Observer_TEvent_Data_Object_ptrTypedefsNC
typedef TEvent_Data_Object* TEvent_Data_Object_ptr;
#endif

#ifndef TEvent_Data_Observer_TEvent_Data_Object_ptrTypedefs
#define TEvent_Data_Observer_TEvent_Data_Object_ptrTypedefs
typedef const TEvent_Data_Object* TEvent_Data_Object_cptr;
#endif

class TEvent_Data_Object_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_Data_Object_var &IT_s);

    public:

    TEvent_Data_Object_var (const TEvent_Data_Object_var &IT_s);
    TEvent_Data_Object_var ();
    TEvent_Data_Object_var (TEvent_Data_Object_ptr IT_p);
    TEvent_Data_Object_var &operator= (TEvent_Data_Object_ptr IT_p);
    TEvent_Data_Object_var &operator= (const TEvent_Data_Object_var &IT_s);
    ~TEvent_Data_Object_var ();
    TEvent_Data_Object_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Object_ptr& () ;
    operator const TEvent_Data_Object_cptr& () const;
    operator TEvent_Data_Object& () const;

    const TEvent_Data_Object in () const;
    TEvent_Data_Object& inOut ();
    TEvent_Data_Object*& out ();
    TEvent_Data_Object* ret () const;
    protected:
    TEvent_Data_Object_ptr* _indPtr;
    TEvent_Data_Object_ptr& _ptr;
    private:
    static TEvent_Data_Object_ptr* _newPtr ();
    TEvent_Data_Object_var &operator= (const CORBA::_var &IT_s);
    TEvent_Data_Object_var (const CORBA::_var &IT_s);
};

#endif


#endif

        virtual void notify (Domain_Repository::Repository_Item_Id id, const TEvent_Data_Object& sd, Domain_Repository::Change_Type change, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
        virtual void abort (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
};

#ifndef TEvent_Data_ObserverVarH
#define TEvent_Data_ObserverVarH

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif

class TEvent_Data_Observer_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_Data_Observer_var &IT_s);
    unsigned char copyHelper (const TEvent_Data_Observer_mgr &IT_s);
    unsigned char copyHelper (const TEvent_Data_Observer_SeqElem &IT_s);

    public:

    TEvent_Data_Observer_var (const TEvent_Data_Observer_var &IT_s);
    TEvent_Data_Observer_var (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_var (const TEvent_Data_Observer_SeqElem &IT_s);
    TEvent_Data_Observer_var ();
    TEvent_Data_Observer_var (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_var &operator= (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_var &operator= (const TEvent_Data_Observer_var &IT_s);
    TEvent_Data_Observer_var &operator= (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_var &operator= (const TEvent_Data_Observer_SeqElem &IT_s);
    ~TEvent_Data_Observer_var ();
    TEvent_Data_Observer_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Observer_ptr& () ;
    operator const TEvent_Data_Observer_cptr& () const;

    operator CORBA::Object_ptr () const;
    TEvent_Data_Observer_ptr in () const;
    TEvent_Data_Observer_ptr& inOut ();
    TEvent_Data_Observer_ptr& out ();
    TEvent_Data_Observer_ptr ret () const;
    protected:
    TEvent_Data_Observer_ptr* _indPtr;
    TEvent_Data_Observer_ptr& _ptr;
    private:
    static TEvent_Data_Observer_ptr* _newPtr ();
    TEvent_Data_Observer_var &operator= (const CORBA::_var &IT_s);
    TEvent_Data_Observer_var (const CORBA::_var &IT_s);
};

#endif



#define TIE_TEvent_Data_Observer(X) TEvent_Data_Observer##X

#define DEF_TIE_TEvent_Data_Observer(X) \
	class TEvent_Data_Observer##X : public virtual TEvent_Data_Observer {		\
	  X* m_obj;						\
	public:							\
								\
								\
	   TEvent_Data_Observer##X  (X *objp, const char* m="", CORBA::LoaderClass *l=0)\
		: TEvent_Data_Observer(), m_obj(objp) {	\
		m_pptr = new TEvent_Data_Observer_dispatch		\
			(( TEvent_Data_Observer*)this,(CORBA::Object*)this,m,l,TEvent_Data_Observer_IR,m_obj);	\
	   }								\
	   TEvent_Data_Observer##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=0)\
		: TEvent_Data_Observer() {	\
		m_pptr = new TEvent_Data_Observer_dispatch		\
			(( TEvent_Data_Observer*)this,(CORBA::Object*)this,IT_m,TEvent_Data_Observer_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~TEvent_Data_Observer##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
virtual void notify (Domain_Repository::Repository_Item_Id id, const TEvent_Data_Observer::TEvent_Data_Object& sd, Domain_Repository::Change_Type change, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->notify (  id,  sd,  change,IT_env);\
}\
	\
virtual void abort (CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->abort (IT_env);\
}\
								\
	};						\


#define QUALS_TEvent_Data_Observer	\
virtual void notify (Domain_Repository::Repository_Item_Id id, const TEvent_Data_Observer::TEvent_Data_Object& sd, Domain_Repository::Change_Type change, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->notify (  id,  sd,  change,IT_env);\
}\
	\
virtual void abort (CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->abort (IT_env);\
}\




class TEvent_Data_ObserverProxyFactoryClass : public virtual CORBA::ObjectFactoryClass {
public:
   TEvent_Data_ObserverProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (TEvent_Data_Observer_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual CORBA::Object* NewObject (char *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* New2Object (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

extern TEvent_Data_ObserverProxyFactoryClass TEvent_Data_ObserverProxyFactory;

#endif


#endif
